/*
 *	main.c
 *
 *	SLIPT[o
 *
 *	* Fri Aug 05 19:07:00 JST 2005 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	app_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
	pceLCDSetBuffer(vbuff);
	pceLCDDispStart();
	pcePadSetTrigMode(PP_MODE_SINGLE);

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* IPAhX̏lݒ肵܂B */
	ip_address = 192<<24|168<<16|255<<8|1;

	/* PCrunŎsꍇUSB̂߂ɁAxď܂B */
	delay(SEC(0.1));
	slip_open(0/*MTU=l:1006oCg()*/, rxdone, NULL);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* mɐؒf܂B */
	slip_close();
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned char rep[8]; /* I[gs[gJE^ */
	//
	int x;
	int y;

	/* ʍXVB */
	pceLCDTrans();

	/* VXeB */
	yield();

	/* pbhԍXVB */
	joy = pcePadGet();

	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}

	/* O[o^C}XVB */
	now++;
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	app_main
 ****************************************************************************/

void
app_main()
{
	int seg[4];

	sel = 3;
	for(;;) {
		schedule();

		/* SELECT{^ŏIB */
		if(joy & TRG_SELECT) {
			break;
		}

		/* IPAhXIB */
		if((joy & TRG_LF) && (sel > 0)) {
			sel--;
		}
		if((joy & TRG_RI) && (sel < 3)) {
			sel++;
		}

		/* IPAhXB */
		seg[0] = (ip_address>>24) & 255;
		seg[1] = (ip_address>>16) & 255;
		seg[2] = (ip_address>> 8) & 255;
		seg[3] = (ip_address>> 0) & 255;
		if((joy & TRG_DN) && (seg[sel] > 0)) {
			seg[sel]--;
		}
		if((joy & TRG_UP) && (seg[sel] < 255)) {
			seg[sel]++;
		}
		ip_address = (seg[0]<<24) | (seg[1]<<16) | (seg[2]<<8) | (seg[3]<<0);

		/* J[\_ŃJE^XVB */
		if(joy & (PAD_UP | PAD_DN)) {
			blink = 0;
		} else {
			blink++;
		}

		/* ʕ\B */
		disp();
	}

}

/****************************************************************************
 *	
 ****************************************************************************/

void
rxdone()
{
	IPHEADER hdr;
	int len;

	len = slip_recv(ipbuf, sizeof ipbuf);
	len = ip_unpack_header(&hdr, ipbuf, len);
	if(len < 0) {
		return;
	}
	if(hdr.destination_ip_address != ip_address) {
		return;
	}
	if(hdr.data_length < 4) {
		return;
	}
	if(hdr.data[0] != 8) { /* ICMP echo erquest */
		return;
	}

	XCHG(hdr.source_ip_address, hdr.destination_ip_address);
	hdr.data[0] = 0; /* ICMP echo reply */
	update_internet_checksum(hdr.data, hdr.data_length, 2);
	len = ip_pack_header(&hdr, ipbuf, sizeof ipbuf);
	if(len < 0) {
		return;
	}

	slip_send(ipbuf, len);
}

/****************************************************************************
 *	disp
 ****************************************************************************/

void
disp()
{
	int seg[4];
	UIOSTAT us;
	SLIPSTAT ss;
	int i;
	int x;
	int y;

	seg[0] = (ip_address>>24) & 255;
	seg[1] = (ip_address>>16) & 255;
	seg[2] = (ip_address>> 8) & 255;
	seg[3] = (ip_address>> 0) & 255;

	uio_stat(&us);
	slip_stat(&ss);

	memset(vbuff, 0, sizeof vbuff);
	pceFontSetType(0x80);
	pceFontSetTxColor(0);
	pceFontSetBkColor(3);
	pceFontSetPos((DISP_X - 5 * 25) / 2, 0);
	/*             OPQRSTUVWXOPQ */
	pceFontPutStr("==== SLIPް(ping) ====");
	x = 4;
	y = 10;
	render_rectangle_fill(&render, 0, y, DISP_X, 10, 1);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	pceFontSetPos(x, y);
	pceFontPrintf("IPڽF");
	for(i = 0; i < 4; i++) {
		pceFontSetTxColor(3);
		pceFontSetBkColor(-1);
		if(i == sel) {
			if(blink % SEC(0.5) < SEC(0.3)) {
				pceFontSetTxColor(0);
				pceFontSetBkColor(2);
			}
		}
		pceFontPrintf("%d", seg[i]);
		pceFontSetTxColor(3);
		pceFontSetBkColor(-1);
		if(i != 3) {
			pceFontPrintf(".");
		}
	}
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	y += 12;
	pceFontSetPos(x, y);
	pceFontPrintf("MoCg@F%8u", us.rxlog % 100000000);
	y += 9;
	pceFontSetPos(x, y);
	pceFontPrintf("MoCg@F%8u", us.txlog % 100000000);
	y += 9;
	pceFontSetPos(x, y);
	pceFontPrintf("G[񐔁F%8u", us.rxerr % 100000000);
	y += 9;
	pceFontSetPos(x, y);
	pceFontPrintf("޼  F%8u", ss.cslog % 100000000);
	y += 9;
	pceFontSetPos(x, y);
	pceFontPrintf("MpPbgF%8u", ss.rxlog % 100000000);
	y += 9;
	pceFontSetPos(x, y);
	pceFontPrintf("MpPbgF%8u", ss.txlog % 100000000);
	pceFontSetTxColor(0);
	pceFontSetBkColor(2);
	pceFontSetPos((DISP_X - 10 * 13) / 2, DISP_Y - 10);
	/*             OPQRSTUVWXOPQ */
	pceFontPutStr(" SELECT{^ŏI܂ ");
	pceLCDTrans();
}

